const JSCOConstants = {
		PREF:		Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
		JSCOPREF:	Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.jsconsoleoutput."),
		CONSOLE:	Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),
		OUTPUTDIR:	Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile),
		LOGFILE:	"jsconsole.log",
		MONTHS:		["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
		CONVERTER:	Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter)
};

var JSCOUtils = {
	getDateTime:	function() {
						var now			= new Date();
						var dateTime	= new Array();
						
						var month = JSCOConstants.MONTHS[now.getMonth()].substr(0,3);
						
						dateTime.push(now.getDate());
						dateTime.push(month);
						dateTime.push(now.getFullYear());
						dateTime.push(now.getHours());
						dateTime.push(now.getMinutes());
						dateTime.push(now.getSeconds());
						
						/* Format the date string */
						for(var i=0;i<dateTime.length;i++) {
							if(dateTime[i].toString().length==1) dateTime[i] = "0".concat(dateTime[i]);						
						}
						
						var messageDate	=	"[" + dateTime[0] + "-" + dateTime[1] + "-" + dateTime[2];
						messageDate		+=	" " + dateTime[3] + ":" + dateTime[4] + ":" + dateTime[5] + "]\t";
						
						return messageDate;
					}
}