var JSConsoleOutput = {

	onLoad:	function() {
				/* Choose a character encoding */ 
				JSCOConstants.CONVERTER.charset = "UTF-8";

				/* Check for the existence of our directory
				 * in the current profile folder
				 */
				JSCOConstants.OUTPUTDIR.append("JSConsoleOutput");
				
				if(!JSCOConstants.OUTPUTDIR.exists()) {
					JSCOConstants.OUTPUTDIR.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
				}

				/* Append the log file name */
				JSCOConstants.OUTPUTDIR.append(JSCOConstants.LOGFILE);				

				/* Check again, now for log file existence */
				if(!JSCOConstants.OUTPUTDIR.exists()) {
					JSCOConstants.OUTPUTDIR.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
				}

				prefObserver.register();
			
				var blnRedirect = JSCOConstants.JSCOPREF.getBoolPref("redirect");

				if(blnRedirect) {
					m = document.getElementById('menuitem_jsconsoleoutput');
					document.persist(m, blnRedirect);
					JSCOConstants.CONSOLE.registerListener(consoleListener);
				}
			},
			
	
	onUnload:	function() {
					JSCOConstants.CONSOLE.unregisterListener(consoleListener);
					prefObserver.unregister();
				},
				

	toggleRedirect:	function() {
						/* Get the current value for the redirect preference */
						var blnRedirect = JSCOConstants.JSCOPREF.getBoolPref("redirect");
					
						/* Set the new value */
						JSCOConstants.JSCOPREF.setBoolPref("redirect", !blnRedirect);
					
						/* Update the menu item appearance */
						var m = document.getElementById('menuitem_jsconsoleoutput');
						document.persist(m, !blnRedirect);
					},
					
	writeToFile:	function(aMessage) {
						try {
							aContent = JSCOConstants.CONVERTER.ConvertFromUnicode(aMessage);

							var ostream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
								ostream.init(JSCOConstants.OUTPUTDIR, 0x02 | 0x08 | 0x10, 0x200, false);

								ostream.write(aContent, aContent.length);
								ostream.close();
						} catch(ex) {
							alert("Unable to redirect console output to a file.");
						}	
					}
};

window.addEventListener("load",	function() {
									if (!JSConsoleOutput._loaded) {
										JSConsoleOutput.onLoad();
										JSConsoleOutput._loaded = true;
									}
								},
false);

window.addEventListener("unload",	function() {
										if (JSConsoleOutput._loaded) {
											JSConsoleOutput.onUnload();
											JSConsoleOutput._loaded = false;
										}
									},
false);