var prefObserver = {

	register:	function() {
					this._branch = JSCOConstants.JSCOPREF;
					this._branch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
					this._branch.addObserver("", this, false);
				},

	unregister:	function() {
					if(!this._branch) return;
					this._branch.removeObserver("", this);
				},

	observe:	function(aSubject, aTopic, aData) {
				    if(aTopic != "nsPref:changed") return;
				    // aSubject is the nsIPrefBranch we're observing
				    // aData is the name of the pref that's been changed (relative to aSubject)
				    switch (aData) {
				      case "redirect":
					    // var blnRedirect = aSubject.getBoolPref(aData);
					    var blnRedirect = this._branch.getBoolPref(aData);

						if(blnRedirect) {
							//dump("Registering\n");
							JSCOConstants.CONSOLE.registerListener(consoleListener);
						} else {
							//dump("Unregistering\n");
							JSCOConstants.CONSOLE.unregisterListener(consoleListener);
						}
				        break;
				    }
				}
};
